
; 
Proc LibAnInit()
     clear clearall
     message "Libraries Analysis and Report - initializing..."
     if istable("DIRTAB") then delete "DIRTAB" endif
     Run norefresh "DIR2DB "+dd+"*.LIB > NUL"
     dynarray ly[]
     if not istable("DIRTAB") or isempty("DIRTAB")
        then Message "No libraries found in "+dd
        else
             view "DIRTAB"
             SCAN 
               ly[dd+[Nome]]=[Nome]
             ENDSCAN 
             delete "DIRTAB"
     endif
     Message ""
     return true
endproc
; 
Proc LibAn()
     Tkecho off
     showpulldown endmenu
     prompt ""
     release vars all
     dd=directory() dd0=dd dd00=dd
     LibAnInit()
     Tkecho normal
     ; PaintPAL_Generated_Code_Begin(496535066)

     SHOWDIALOG ""  ; I:\DLG\PICLIB2.DLG
        PROC "evPicLib"
           KEY "Del"
           TRIGGER "DEPART", "ACCEPT", "CANCEL"

        @2,0 HEIGHT 21 WIDTH 49

        ; PaintPAL_Frame_Begin
        FRAME SINGLE FROM 4,0 TO 16,46
        PAINTCANVAS BORDER ATTRIBUTE 126 4,0,16,46
        ; PaintPAL_Frame_End

        ; PaintPAL_Static_Text_Begin
        PAINTCANVAS FILL " " ATTRIBUTE 126 14,9,15,37
        @14,9
        ?? "   Press Del to remove the"
        @15,9
        ?? "  highlighted library file"
        PAINTCANVAS ATTRIBUTE 126 14,9,15,37
        ; PaintPAL_Static_Text_End

        ; PaintPAL_Static_Text_Begin
        PAINTCANVAS FILL " " ATTRIBUTE 126 5,7,5,38
        @5,7
        ?? "Include the following libraries:"
        PAINTCANVAS ATTRIBUTE 126 5,7,5,38
        ; PaintPAL_Static_Text_End

        ACCEPT @2,1 WIDTH 45
           "A44"
           REQUIRED
           TAG "dd.tag"
           TO dd

        LABEL @1,12
           "Analize Libraries in:"
           FOR "dd.tag"

        PICKDYNARRAY @6,2 HEIGHT 8 WIDTH 42
           COLUMNS 3
           ly
           TAG "l.tag"
           TO l

        PUSHBUTTON @17,0 WIDTH 15
           "~O~k, proceed"
           OK
           DEFAULT
           TO retval

        PUSHBUTTON @17,31 WIDTH 15
           "~E~xit"
           CANCEL
           TAG "c.tag"
           TO c
     ENDDIALOG

     ; PaintPAL_Generated_Code_End(496535066)
endproc
; 
Proc evPicLib(TT,TagVal,EV, EleVal)
Private nomepr,atty
   SWITCH

     case TT="DEPART" and tagval="dd.tag" and dd<>dd0:
          Tkecho off
          if substr(dd,len(dd),1)<>"\\" then dd=dd+"\\" endif
          dd=upper(dd) dd0=dd
          if direxists(dd)=1 then
             sound 100 100 sound 500 50 sound 1200 100
             LibAnInit()
          else
             sound 100 150 sound 20 100
          endif 
          REFRESHCONTROL "l.tag"
          REFRESHCONTROL "dd.tag"
          ;REPAINTDIALOG
          RESYNCDIALOG
          Tkecho normal
          return false; true

     case TT="CANCEL" :
          tkecho off
          setcanvas default
          ;clear clearall
          if istable("PROCLIST") then
             view "PROCLIST" WINMAX
             copyreport "EPL" "R" "PROCLIST" "R"
             copyreport "EPL" "1" "PROCLIST" "1"
          endif
          CANCELDIALOG return true

     case TT="ACCEPT":
          ;;no--if istable("PROCLIST") then delete "PROCLIST" endif
          if dynarraysize(ly) <1 then
                    Message "No library selected !"
                    SELECTCONTROL "l.tag" return false endif
          ;;window move whdb to dbrow,dbcol
          ;;SELECTCONTROL "dalsk.tag"
          Tkecho off
          if istable(dd00+"PROCLIST") then
             showpopup "Output table PROCLIST exists" centered
               "Overwrite":"":"Ov",
               "Append"   :"":"Ap"
             endmenu to choice
             if choice="Ov" then
                delete dd00+"PROCLIST"
             endif
          endif
          Message "Working, wait please..."
;          create "PROCLIST"
;                 "Procedure"                 :  "A31",
;                 "LibName"                   :  "A12",
;                 "ScriptPathName"            :  "A80",
;                 "ScriptName"                :  "A80",
;                 "Version"                   :  "A3",
;                 "Bytes"                     :  "S"
          j=0
          filewrite "$.BAT" from "@echo off\n:LIBAN temporary batch\n"
          foreach i in ly
             j=j+1
             parsefilename i to x
             if len(x["PATH"])>1 and substr(x["PATH"],len(x["PATH"]),1)="\\" then
                x["PATH"]=substr(x["PATH"],1,len(x["PATH"])-1)
             endif
             filewrite append "$.BAT" from
                       x["DRIVE"]+" > NUL\nCD"+x["PATH"]+">NUL\n"
             filewrite append "$.BAT" from
                       dd00+"LIBAN "+ly[i]+" "+dd00+"PROCLIST /A > NUL\n" ;;?? > NUL"
          endforeach
          Run norefresh "$.BAT > NUL"
          Run norefresh "del $.BAT > NUL"
          Tkecho off ;ridato..??
          if istable("PROCLIST") and not isempty("PROCLIST") then
             coedit "PROCLIST"
             SCAN
               if isblank([ScriptPathName]) then Loop endif
               parsefilename [ScriptPathName] to x
               if isblank(x["FILE"]) then Loop endif
               [ScriptName]=x["FILE"]
             ENDSCAN
             DO_IT! clearimage
          endif
          Tkecho normal
          SELECTCONTROL "l.tag"
          ;REFRESHCONTROL "dd.tag"
          ;REPAINTDIALOG
          ;RESYNCDIALOG
          Message "Ok !"
          return false ; resta sempre in db

     case TT="EVENT" and isassigned(EV["KEYCODE"]) and EV["KEYCODE"]=-35:; HELP
          SpeBISHelp(TagVal)

     case TT="EVENT" and isassigned(EV["KEYCODE"]) and EV["KEYCODE"]=-83:
          if tagval<>"l.tag" then
             Message "Please press DEL on the lib you want to unselect"
             sound 100 500 return true
          endif
          release vars ly[l]
          REFRESHCONTROL "l.tag"
          sound 800 100 sound 400 50 sound 600 100
          ;Tkecho off
          ;Tkecho normal

;     case TT="EVENT": ;altri event non listati (tipo mouse..)
;     otherwise: beep

   ENDSWITCH
   RETURN TRUE
Endproc

LibAn()

